/* Copyright (C) 2017 Advanced Digital Sciences Centre
 * 
 * This is a software-based attestation demo code developed at Advanced Digital Sciences Center.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * It is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * @author: Sumeet Jauhar, Prageeth Mahendra Gunathilaka
 */

/* 
 * File:   MemoryStride.h
 * Author: Sumeet Jauhar, Prageeth Mahendra Gunathilaka
 *
 * Created on 23 May, 2016, 7:11 PM
 */

#ifndef MemoryStride_H
#define MemoryStride_H

#ifdef __cplusplus
extern "C" {
#endif

#define RAM_SIZE 16384//16320  // 0x3FC0
unsigned long final_hexM[RAM_SIZE];
char stringM[10];
char bufferM[48];
char checksumM[48];
char temp1[96];

unsigned int parse_char (char c);
unsigned long ADDwithFlagUpdateM(unsigned long r1, unsigned long r2, unsigned long cpsr);
unsigned long RamAddressMappingM(int arrayId);
unsigned long SUBwithFlagUpdateM(unsigned long r1, unsigned long r2, unsigned long cpsr);
void strideMemory(char *simulatedMainRes, char *memoryLogFile, 
                    unsigned long *seeds, unsigned long iterations);
void computeChecksumM(long long r1);

#ifdef __cplusplus
}
#endif

#endif /* MemoryStride_H */

