/* Copyright (C) 2017 Advanced Digital Sciences Centre
 * 
 * This is a software-based attestation demo code developed at Advanced Digital Sciences Center.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * It is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * @author: Toby Zhou.Bin
 */

/* 
 * File:   Utils.h
 * Author: Zhou Bin
 *
 * Created on 14 Sep, 2017, 5:10 PM
 */

#ifndef UTILS_H
#define UTILS_H

#ifdef __cplusplus
extern "C" {
#endif

#define KNRM  "\x1B[0m"
#define KRED  "\x1B[31m"
#define KGRN  "\x1B[32m"
#define KYEL  "\x1B[33m"
#define KBLU  "\x1B[34m"
#define KMAG  "\x1B[35m"
#define KCYN  "\x1B[36m"
#define KWHT  "\x1B[37m"


void colorLog(char * color, unsigned char * content);

void displayInHex(const unsigned char *str, int n);

unsigned long stringToHex(unsigned char * value, int size);

unsigned long long int hex2int(char *a, unsigned int len);

unsigned long _rotr(unsigned long value, int shift);

float timedifference_msec(struct timeval t0, struct timeval t1);

int isValidValue(char value);


// Config
void getVerifierConfig(char* memoryImg, char* IP, int* portNum,
                       int* timeThreshold, unsigned long* iterations);

void getProverConfig(char* memoryImg, int* portNum);


// Socket & Connection
int createSocket();

struct hostent * findProver(char * proverIP);

int connectProver(int sockfd, struct sockaddr * serveraddr, int serveraddr_size);

/*
void display(const unsigned char *str, int n);
unsigned long ADDwithFlagUpdate(unsigned long r1, unsigned long r2, unsigned long cpsr);
unsigned long SUBwithFlagUpdate(unsigned long r1, unsigned long r2, unsigned long cpsr);

unsigned int charToNum (char c);
*/

#ifdef __cplusplus
}
#endif

#endif /* UTILS_H */

